Main Page | Modules | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | Related Pages

# SoDirectionalLightDragger Class Reference
[Draggers]

`#include <Inventor/draggers/SoDirectionalLightDragger.h>`

Inheritance diagram for SoDirectionalLightDragger:

List of all members.

## Detailed Description

The SoDirectionalLightDragger class provides interactive geometry for manipulating a directional light source.

Here's how the dragger looks with it's default geometry in the inactive state:

This dragger is well suited to use for setting up the fields of a SoDirectionalLight node, as it provides geometry for the end-user to interact with a directional vector.

For convenience, this dragger also by default contains interaction geometry for placing the dragger itself. (SoDirectionalLight nodes don't have a position field, so this was strictly not needed.)

The Coin library also includes a manipulator class, SoDirectionalLightManip, which wraps the functionality provided by this class inside the necessary mechanisms for connecting it to SoDirectionalLight node instances in a scenegraph.

See also:
  SoDirectionalLightManip

## Public Member Functions
| SoDirectionalLightDragger (void)
## Static Public Member Functions
void | initClass (void)
## Public Attributes
SoSFRotation | rotation
SoSFVec3f | translation
## Protected Member Functions
| ~SoDirectionalLightDragger ()
virtual SbBool | setUpConnections (SbBool onoff, SbBool doitalways=FALSE)
virtual void | setDefaultOnNonWritingFields (void)
## Static Protected Member Functions
void | fieldSensorCB (void *f, SoSensor *s)
void | valueChangedCB (void *f, SoDragger *d)
## Protected Attributes
SoFieldSensor * | rotFieldSensor
SoFieldSensor * | translFieldSensor

## Constructor & Destructor Documentation

SoDirectionalLightDragger::SoDirectionalLightDragger | ( | void |  | ) |

| Default constructor, sets up the dragger nodekit catalog with the interaction and feedback geometry. Node kit structure (new entries versus parent class marked with arrow prefix):
      CLASS SoDirectionalLightDragger
      -->"this"
            "callbackList"
            "topSeparator"
               "motionMatrix"
      -->      "material"
      -->      "translatorSep"
      -->         "translatorRotInv"
      -->         "translator"
      -->      "rotator"
               "geomSeparator"
(See SoBaseKit::printDiagram() for information about the output formatting.) Detailed information on catalog parts:
      CLASS SoDirectionalLightDragger
      PVT   "this",  SoDirectionalLightDragger  ---
            "callbackList",  SoNodeKitListPart [ SoCallback, SoEventCallback ]
      PVT   "topSeparator",  SoSeparator  ---
      PVT   "motionMatrix",  SoMatrixTransform  ---
            "material",  SoMaterial  ---
      PVT   "translatorSep",  SoSeparator  ---
            "translatorRotInv",  SoRotation  ---
            "translator",  SoDragPointDragger  ---
            "rotator",  SoRotateSphericalDragger  ---
      PVT   "geomSeparator",  SoSeparator  ---
(See SoBaseKit::printTable() for information about the output formatting.)

SoDirectionalLightDragger::~SoDirectionalLightDragger | ( |  | ) | `[protected]`

| Protected destructor. (Dragger classes are derived from SoBase, so they are reference counted and automatically destroyed when their reference count goes to 0.)

## Member Function Documentation

void SoDirectionalLightDragger::initClass | ( | void |  | ) | `[static]`

| Initializes type system for this dragger class. Application programmers should usually not have to invoke this method, see documentation of SoInteraction::init(). Reimplemented from SoDragger.

SbBool SoDirectionalLightDragger::setUpConnections | ( | SbBool | onoff,
|  | SbBool | doitalways = FALSE
| ) | `[protected, virtual]`

| Sets up all internal connections for instances of this class. (This method will usually not be of interest to the application programmer, unless you want to extend the library with new custom nodekits or dragger classes. If so, see the SoBaseKit class documentation.) Reimplemented from SoInteractionKit.

void SoDirectionalLightDragger::setDefaultOnNonWritingFields | ( | void |  | ) | `[protected, virtual]`

| (Be aware that this method is unlikely to be of interest to the application programmer who does not want to extend the library with new custom nodekits or draggers. If you indeed are writing extensions, see the information in the SoBaseKit class documentation.) This is a virtual method, and the code in it should call SoField::setDefault() with argument `TRUE` on part fields that should not be written upon scenegraph export operations. This is typically done when: field value is `NULL` and part is `NULL` by default it is a leaf SoGroup or SoSeparator node with no children it is a leaf listpart with no children and an SoGroup or SoSeparator container it is a non-leaf part and it's of SoGroup type and all fields are at their default values Subclasses should usually override this to do additional settings for new member fields. From the subclass, do remember to call "upwards" to your superclass' setDefaultOnNonWritingFields() method. Reimplemented from SoDragger.

void SoDirectionalLightDragger::fieldSensorCB | ( | void * | d,
|  | SoSensor * | s
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Reimplemented from SoInteractionKit.

void SoDirectionalLightDragger::valueChangedCB | ( | void * | f,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## Member Data Documentation

SoSFRotation SoDirectionalLightDragger::rotation

| This field is continuously updated to contain the rotation of the current direction vector. The application programmer will typically connect this to the rotation field of a SoDirectionalLight node (unless using the SoDirectionalLightManip class, where this is taken care of automatically). It may also of course be connected to any other rotation field controlling the direction of scenegraph geometry, it does not have to part of a SoDirectionalLight node specifically.

SoSFVec3f SoDirectionalLightDragger::translation

| Continuously updated to contain the current translation from the dragger's local origo position. This field is not used by the SoDirectionalLightManip, but may be of interest for the application programmer wanting to use the SoDirectionalLightDragger outside the context of controlling a directional light node.

SoFieldSensor * SoDirectionalLightDragger::rotFieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SoFieldSensor * SoDirectionalLightDragger::translFieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

The documentation for this class was generated from the following files:

- SoDirectionalLightDragger.h
- SoDirectionalLightDragger.cpp